
/*  A Bison parser, made from WebScriptGrammar.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse WebScriptGrammarparse
#define yylex WebScriptGrammarlex
#define yyerror WebScriptGrammarerror
#define yylval WebScriptGrammarlval
#define yychar WebScriptGrammarchar
#define yydebug WebScriptGrammardebug
#define yynerrs WebScriptGrammarnerrs
#define	INTERFACE	258
#define	IMPLEMENTATION	259
#define	END	260
#define	IDENT	261
#define	AUTODOCCOMMENT	262
#define	COPYRIGHTCOMMENT	263
#define	STATICTYPE	264
#define	ELLIPSES	265
#define	SQUIGGLEBLOCK	266
#define	METHODSTART	267

#line 2 "WebScriptGrammar.y"

	#import <Foundation/NSDictionary.h>
	#import <Foundation/NSPathUtilities.h>
	#import <Foundation/NSUtilities.h>
	#import <MiscFoundation.subproj/NSString+MiscRegex.h>
	#import <stdio.h>
	#import <stdlib.h>
	#import <string.h>

	#import "ADClass.h"
	#import "ADComment.h"
	#import "ADCategory.h"
	#import "ADMethod.h"
	#import "ADFile.h"
	#import "ADIvar.h"
	#import "ADDefaults.h"
	#import "ADUtilities.h"

	/* Is there a better way to handle this? */
	#undef yylex
	#define yylex WebScriptTokenizerlex
	
	/* Use our logging function, so we can control where output goes */
	#define fprintf adfprintf

	/* Define some values, since we can't use the '@' character inside bison rules */
	#define EMPTYSTRING @""
	#define NSSTRING(cstring) [NSString stringWithCString:cstring]
	
	typedef struct _MethodArg {
		NSString *argName;
		NSString *argType;
		NSString *varName;
	} MethodArg;
	
	
	int yyerror(char *s);
	int yylex();

	#define YYDEBUG 1
	#define YYERROR_VERBOSE 1
	
//	YYPARSE_PARAM doesn't work because of a snafu in bison.simple
//	#define YYPARSE_PARAM fileContents
//	#define ADFILE (ADFile *)fileContents
	static ADFile *globalFileContents;
	#define ADFILE (ADFile *)globalFileContents

    /*
     * WOScript files don't have to formally declare the class they're
     * defining -- the class is assumed to be the same name as the input
     * file less the ".wos", and it's (usually) assumed to inherit from
     * WOComponent.  Any bare variable declarations are instance variables
     * of this class, and any bare method implmentations are methods of it.
     * The "globalClass" variable holds this implied class, and we add the
     * ivars and methods as they're parsed.  This class is the
     * -mainInterface of the ADFile, unless no methods were implemented for
     * it, in which case we assume everything is inside
     * @interface/@implementation sections and therefore ignore this
     * assumed class.
     */	   
	static ADClass *globalClass;

#line 101 "WebScriptGrammar.y"
typedef union
{
	NSString *stringVal;
	int		intVal;
	char	charVal;
	MethodArg  methodArg;
	NSArray  *array;
	NSMutableArray *mutableArray;
	id	 object;
	ADMethod *method;
	ADIvar *ivar;
	ADComment *comment;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		96
#define	YYFLAG		-32768
#define	YYNTBASE	23

#define YYTRANSLATE(x) ((unsigned)(x) <= 267 ? yytranslate[x] : 46)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    14,
    15,    22,     2,    18,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    13,    21,    16,
     2,    17,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    19,     2,    20,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     6,     9,    19,    26,    35,    37,    39,
    41,    46,    52,    56,    62,    63,    67,    69,    73,    74,
    78,    79,    82,    85,    89,    91,    95,    97,    99,   102,
   103,   105,   106,   109,   116,   118,   120,   121,   124,   134,
   136,   137,   139,   140,   143,   144,   146,   147,   150,   155,
   157,   158
};

static const short yyrhs[] = {    -1,
    35,    24,     0,    25,     0,    24,    25,     0,     3,     6,
    13,     6,    27,    35,    29,    36,     5,     0,     3,     6,
    27,    29,    36,     5,     0,     3,     6,    14,     6,    15,
    27,    36,     5,     0,     8,     0,    39,     0,    31,     0,
    26,    35,    38,     5,     0,     4,     6,    13,     6,    29,
     0,     4,     6,    29,     0,     4,     6,    14,     6,    15,
     0,     0,    16,    28,    17,     0,     6,     0,     6,    18,
    28,     0,     0,    19,    30,    20,     0,     0,    30,    31,
     0,    32,    35,     0,     6,    33,    21,     0,    34,     0,
    33,    18,    34,     0,     1,     0,     6,     0,    22,     6,
     0,     0,     7,     0,     0,    36,    37,     0,    12,    42,
     6,    43,    41,    21,     0,     7,     0,     1,     0,     0,
    38,    39,     0,    35,    12,    42,     6,    43,    41,    40,
    35,    11,     0,     1,     0,     0,    21,     0,     0,    18,
    10,     0,     0,     9,     0,     0,    43,    44,     0,    45,
    13,    42,     6,     0,     1,     0,     0,     6,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   117,   118,   125,   126,   129,   141,   150,   159,   164,   168,
   173,   190,   194,   198,   218,   219,   222,   223,   226,   227,
   229,   230,   232,   239,   259,   260,   261,   264,   265,   268,
   269,   272,   273,   275,   284,   288,   291,   292,   295,   309,
   311,   312,   316,   317,   320,   321,   324,   328,   335,   341,
   349,   350
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","INTERFACE",
"IMPLEMENTATION","END","IDENT","AUTODOCCOMMENT","COPYRIGHTCOMMENT","STATICTYPE",
"ELLIPSES","SQUIGGLEBLOCK","METHODSTART","':'","'('","')'","'<'","'>'","','",
"'{'","'}'","';'","'*'","file","filepieces","filepiece","implstart","conforms",
"manyconforms","vardecls","manyvardecls","vardecl","ivardecllist","ivarlist",
"ivar","maybecomment","manymethoddecls","methoddecl","manymethodimpls","methodimpl",
"maybesemicolon","maybeellipses","statictype","arguments","argument","maybeident", NULL
};
#endif

static const short yyr1[] = {     0,
    23,    23,    24,    24,    25,    25,    25,    25,    25,    25,
    25,    26,    26,    26,    27,    27,    28,    28,    29,    29,
    30,    30,    31,    32,    33,    33,    33,    34,    34,    35,
    35,    36,    36,    37,    37,    37,    38,    38,    39,    39,
    40,    40,    41,    41,    42,    42,    43,    43,    44,    44,
    45,    45
};

static const short yyr2[] = {     0,
     0,     2,     1,     2,     9,     6,     8,     1,     1,     1,
     4,     5,     3,     5,     0,     3,     1,     3,     0,     3,
     0,     2,     2,     3,     1,     3,     1,     1,     2,     0,
     1,     0,     2,     6,     1,     1,     0,     2,     9,     1,
     0,     1,     0,     2,     0,     1,     0,     2,     4,     1,
     0,     1
};

static const short yydefact[] = {    30,
    31,     0,    40,     0,     0,     0,     8,     0,     3,    30,
    10,    30,     0,     9,    15,    19,    27,    28,     0,     0,
    25,     4,    37,    23,    45,     0,     0,     0,    19,     0,
     0,    21,    13,    29,     0,    24,     0,    46,     0,    15,
     0,    17,     0,    32,    19,     0,     0,    26,    11,    38,
    47,    30,    15,     0,    16,     0,    12,    14,    20,    22,
     0,    19,    32,    18,    36,     6,    35,    45,    33,    50,
    52,     0,    41,    48,     0,    32,     0,     0,    44,    42,
    30,    45,     0,     7,    47,     0,     0,     5,     0,    39,
    49,     0,    34,     0,     0,     0
};

static const short yydefgoto[] = {    94,
     8,     9,    10,    29,    43,    33,    47,    11,    12,    20,
    21,    13,    56,    69,    37,    14,    81,    73,    39,    61,
    74,    75
};

static const short yypact[] = {    30,
-32768,    53,-32768,    32,    44,     1,-32768,    41,-32768,    24,
-32768,    24,    39,-32768,    19,    -8,-32768,-32768,    49,    25,
-32768,-32768,-32768,-32768,    54,    62,    68,    69,    60,    77,
    78,-32768,-32768,-32768,    -3,-32768,    57,-32768,    79,    70,
    73,    71,    74,-32768,    60,    80,     9,-32768,-32768,-32768,
-32768,    24,    70,    69,-32768,    65,-32768,-32768,-32768,-32768,
     7,    60,-32768,-32768,-32768,-32768,-32768,    54,-32768,-32768,
-32768,    82,    72,-32768,    81,-32768,    66,    84,-32768,-32768,
    24,    54,    75,-32768,-32768,    85,    91,-32768,     3,-32768,
-32768,    83,-32768,    98,    99,-32768
};

static const short yypgoto[] = {-32768,
-32768,    92,-32768,   -14,    47,   -28,-32768,    55,-32768,-32768,
    76,     0,   -36,-32768,-32768,    86,-32768,    14,   -46,    20,
-32768,-32768
};


#define	YYLAST		123


static const short yytable[] = {     2,
    44,    17,    18,    70,    30,    31,    18,    70,    71,    23,
    32,    24,    71,   -43,     6,   -51,    57,   -43,    19,   -51,
    72,    78,    19,   -43,    72,    52,    77,   -43,    59,    -1,
     1,    26,    27,    76,    28,    87,     1,    15,    63,    83,
    -2,     3,    35,     4,     5,    36,     6,     1,     7,    16,
    25,    62,   -30,     3,    34,     4,     5,     3,     6,     1,
     7,    49,    38,     1,   -30,    65,    65,    40,   -30,    66,
    84,    67,    67,    41,    42,    65,    68,    68,    32,    88,
    86,    67,    45,    46,    51,    28,    68,    53,    54,    85,
    55,    79,    80,    82,    58,    90,    91,    95,    96,    22,
    64,    60,    92,    93,    89,     0,     0,     0,     0,     0,
    48,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    50
};

static const short yycheck[] = {     0,
    29,     1,     6,     1,    13,    14,     6,     1,     6,    10,
    19,    12,     6,     7,     6,    13,    45,    11,    22,    13,
    18,    68,    22,    21,    18,    40,    63,    21,    20,     0,
     7,    13,    14,    62,    16,    82,     7,     6,    53,    76,
     0,     1,    18,     3,     4,    21,     6,     7,     8,     6,
    12,    52,    12,     1,     6,     3,     4,     1,     6,     7,
     8,     5,     9,     7,    12,     1,     1,     6,    12,     5,
     5,     7,     7,     6,     6,     1,    12,    12,    19,     5,
    81,     7,     6,     6,     6,    16,    12,    15,    18,     6,
    17,    10,    21,    13,    15,    11,     6,     0,     0,     8,
    54,    47,    89,    21,    85,    -1,    -1,    -1,    -1,    -1,
    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    37
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/lib/bison/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/local/lib/bison/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 2:
#line 119 "WebScriptGrammar.y"
{
			/* A comment at the beginning of the file is the class description */
			if (yyvsp[-1].comment) [globalClass setEntityDescription:yyvsp[-1].comment];
		;
    break;}
case 5:
#line 130 "WebScriptGrammar.y"
{
				yyval.object = [[[ADClass alloc] init] autorelease];
				[yyval.object setClassName:yyvsp[-7].stringVal];
				[yyval.object setSuperclassName:yyvsp[-5].stringVal];
				[yyval.object setConformedProtocols:yyvsp[-4].mutableArray];
				[yyval.object setInheritsInfo:yyvsp[-3].comment];
				[yyval.object setIvarArray:yyvsp[-2].mutableArray];
				[yyval.object addDeclarationsFromArray:yyvsp[-1].mutableArray];
				[ADFILE addClass:yyval.object];
			;
    break;}
case 6:
#line 142 "WebScriptGrammar.y"
{
				yyval.object = [[[ADClass alloc] init] autorelease];
				[yyval.object setClassName:yyvsp[-4].stringVal];
				[yyval.object setConformedProtocols:yyvsp[-3].mutableArray];
				[yyval.object setIvarArray:yyvsp[-2].mutableArray];
				[yyval.object addDeclarationsFromArray:yyvsp[-1].mutableArray];
				[ADFILE addClass:yyval.object];
			;
    break;}
case 7:
#line 151 "WebScriptGrammar.y"
{
				yyval.object = [ADCategory category];
				[yyval.object setClassName:yyvsp[-6].stringVal];
				[yyval.object setCategoryName:yyvsp[-4].stringVal];
				[yyval.object setConformedProtocols:yyvsp[-2].mutableArray];
				[yyval.object addDeclarationsFromArray:yyvsp[-1].mutableArray];
				[ADFILE addCategory:yyval.object];
			;
    break;}
case 8:
#line 160 "WebScriptGrammar.y"
{
				yyval.object = nil;
				[ADFILE setCopyrightFromString:yyvsp[0].stringVal];
			;
    break;}
case 9:
#line 165 "WebScriptGrammar.y"
{
				if (yyvsp[0].method) [globalClass addDeclaration:yyvsp[0].method];
			;
    break;}
case 10:
#line 169 "WebScriptGrammar.y"
{
				if (yyvsp[0].mutableArray) [globalClass addIvarsFromArray:yyvsp[0].mutableArray];
			;
    break;}
case 11:
#line 174 "WebScriptGrammar.y"
{
				if (yyvsp[-2].comment) [yyvsp[-3].object setEntityDescription:yyvsp[-2].comment];
				
                /*
                 * If there were methods declared in the @interface
                 * section, then we should just document those.  If there
                 * were none, as is common, we'll document all methods
                 * found while parsing the @implementation.
                 */
				if ([[yyvsp[-3].object declarationArray] count] > 0)
					[yyvsp[-3].object setMethodDescriptionsFromArray:yyvsp[-1].mutableArray];
				else
					[yyvsp[-3].object addDeclarationsFromArray:yyvsp[-1].mutableArray];
			;
    break;}
case 12:
#line 191 "WebScriptGrammar.y"
{
				yyval.object = [ADFILE classNamed:yyvsp[-3].stringVal];
			;
    break;}
case 13:
#line 195 "WebScriptGrammar.y"
{
				yyval.object = [ADFILE classNamed:yyvsp[-1].stringVal];
			;
    break;}
case 14:
#line 199 "WebScriptGrammar.y"
{
				yyval.object = [ADFILE categoryNamed:yyvsp[-1].stringVal forClass:yyvsp[-3].stringVal];
				
                /*
                 * If a category had no @interface section, which is
                 * common, then add the category.  In fact, I'm not sure
                 * WebScript even allows @interface sections for
                 * categories, in which case this is absolutely needed.
                 */
				if (yyval.object == nil)
				{
					yyval.object = [ADCategory category];
					[yyval.object setClassName:yyvsp[-3].stringVal];
					[yyval.object setCategoryName:yyvsp[-1].stringVal];
					[ADFILE addCategory:yyval.object];
				}
			;
    break;}
case 15:
#line 218 "WebScriptGrammar.y"
{ yyval.mutableArray = [NSMutableArray array]; ;
    break;}
case 16:
#line 219 "WebScriptGrammar.y"
{ yyval.mutableArray = yyvsp[-1].mutableArray; ;
    break;}
case 17:
#line 222 "WebScriptGrammar.y"
{ yyval.mutableArray = [NSMutableArray arrayWithObject:yyvsp[0].stringVal]; ;
    break;}
case 18:
#line 223 "WebScriptGrammar.y"
{ yyval.mutableArray = yyvsp[0].mutableArray; [yyval.mutableArray addObject:yyvsp[-2].stringVal]; ;
    break;}
case 19:
#line 226 "WebScriptGrammar.y"
{ yyval.mutableArray = [NSMutableArray array]; ;
    break;}
case 20:
#line 227 "WebScriptGrammar.y"
{ yyval.mutableArray = yyvsp[-1].mutableArray; ;
    break;}
case 21:
#line 229 "WebScriptGrammar.y"
{ yyval.mutableArray = [NSMutableArray array]; ;
    break;}
case 22:
#line 230 "WebScriptGrammar.y"
{ yyval.mutableArray = yyvsp[-1].mutableArray; if (yyvsp[0].mutableArray) [yyval.mutableArray addObjectsFromArray:yyvsp[0].mutableArray]; ;
    break;}
case 23:
#line 233 "WebScriptGrammar.y"
{
				yyval.mutableArray = yyvsp[-1].mutableArray;
				if (yyvsp[0].comment) [[yyval.mutableArray objectAtIndex:0] setEntityDescription:yyvsp[0].comment];
			;
    break;}
case 24:
#line 240 "WebScriptGrammar.y"
{
				int i, count = [yyvsp[-1].mutableArray count];
				yyval.mutableArray = yyvsp[-1].mutableArray;
				
				for (i=0; i<count; i++)
				{
					ADIvar *ivar = [yyval.mutableArray objectAtIndex:i];
					NSString *type = yyvsp[-2].stringVal;

					/* If we assigned a partial type string below, include it. */
					if ([ivar type] != nil)
						type = [type stringByAppendingString:[ivar type]];
					
					[ivar setType:type];
				}
			;
    break;}
case 25:
#line 259 "WebScriptGrammar.y"
{ yyval.mutableArray = [NSMutableArray arrayWithObject:yyvsp[0].ivar]; ;
    break;}
case 26:
#line 260 "WebScriptGrammar.y"
{ yyval.mutableArray = yyvsp[-2].mutableArray; [yyval.mutableArray addObject:yyvsp[0].ivar]; ;
    break;}
case 27:
#line 261 "WebScriptGrammar.y"
{ yyval.mutableArray = nil; ;
    break;}
case 28:
#line 264 "WebScriptGrammar.y"
{ yyval.ivar = [ADIvar ivarWithName:yyvsp[0].stringVal]; [yyval.ivar setType:NSSTRING(" ")];  ;
    break;}
case 29:
#line 265 "WebScriptGrammar.y"
{ yyval.ivar = [ADIvar ivarWithName:yyvsp[0].stringVal]; [yyval.ivar setType:NSSTRING(" *")]; ;
    break;}
case 30:
#line 268 "WebScriptGrammar.y"
{yyval.comment = nil; ;
    break;}
case 31:
#line 269 "WebScriptGrammar.y"
{ yyval.comment = [ADComment commentWithString:yyvsp[0].stringVal]; ;
    break;}
case 32:
#line 272 "WebScriptGrammar.y"
{ yyval.mutableArray = [NSMutableArray array]; ;
    break;}
case 33:
#line 273 "WebScriptGrammar.y"
{ yyval.mutableArray = yyvsp[-1].mutableArray; if (yyvsp[0].method) [yyval.mutableArray addObject:yyvsp[0].method]; ;
    break;}
case 34:
#line 276 "WebScriptGrammar.y"
{
				yyval.method = yyvsp[-2].method;
				[yyval.method setClassMethod:(yyvsp[-5].charVal == '+')];
				[yyval.method setReturnType:yyvsp[-4].stringVal];
				[yyval.method setFirstArgumentName:yyvsp[-3].stringVal];
				if ([yyvsp[-1].stringVal length] > 0)
					[yyval.method setIsVarargMethod:YES];
			;
    break;}
case 35:
#line 285 "WebScriptGrammar.y"
{
				yyval.method = (ADMethod *)[ADComment commentWithString:yyvsp[0].stringVal];
			;
    break;}
case 36:
#line 288 "WebScriptGrammar.y"
{ yyval.method = nil; ;
    break;}
case 37:
#line 291 "WebScriptGrammar.y"
{ yyval.mutableArray = [NSMutableArray array]; ;
    break;}
case 38:
#line 292 "WebScriptGrammar.y"
{ yyval.mutableArray = yyvsp[-1].mutableArray; if (yyvsp[0].method) [yyval.mutableArray addObject:yyvsp[0].method]; ;
    break;}
case 39:
#line 297 "WebScriptGrammar.y"
{
				yyval.method = yyvsp[-4].method;
				[yyval.method setClassMethod:(yyvsp[-7].charVal == '+')];
				[yyval.method setReturnType:yyvsp[-6].stringVal];
				[yyval.method setFirstArgumentName:yyvsp[-5].stringVal];
				if ([yyvsp[-3].stringVal length] > 0)
					[yyval.method setIsVarargMethod:YES];

				/* A comment inside the method block will win if both are present */
				if (yyvsp[-8].comment) [yyval.method setEntityDescription:yyvsp[-8].comment];
				if (yyvsp[-1].comment) [yyval.method setEntityDescription:yyvsp[-1].comment];
			;
    break;}
case 40:
#line 309 "WebScriptGrammar.y"
{yyval.method = nil; ;
    break;}
case 43:
#line 316 "WebScriptGrammar.y"
{yyval.stringVal = EMPTYSTRING;;
    break;}
case 44:
#line 317 "WebScriptGrammar.y"
{yyval.stringVal = yyvsp[0].stringVal; ;
    break;}
case 45:
#line 320 "WebScriptGrammar.y"
{yyval.stringVal = EMPTYSTRING; ;
    break;}
case 46:
#line 321 "WebScriptGrammar.y"
{yyval.stringVal = yyvsp[0].stringVal; ;
    break;}
case 47:
#line 325 "WebScriptGrammar.y"
{
				yyval.method = [ADMethod method];
			;
    break;}
case 48:
#line 329 "WebScriptGrammar.y"
{
				yyval.method = yyvsp[-1].method;
				[yyval.method addArgument:yyvsp[0].methodArg.argName type:yyvsp[0].methodArg.argType varName:yyvsp[0].methodArg.varName];
			;
    break;}
case 49:
#line 336 "WebScriptGrammar.y"
{
				yyval.methodArg.argName = yyvsp[-3].stringVal;
				yyval.methodArg.argType = yyvsp[-1].stringVal;
				yyval.methodArg.varName = yyvsp[0].stringVal;
			;
    break;}
case 50:
#line 342 "WebScriptGrammar.y"
{
				yyval.methodArg.argName = EMPTYSTRING;
				yyval.methodArg.argType = EMPTYSTRING;
				yyval.methodArg.varName = EMPTYSTRING;
			;
    break;}
case 51:
#line 349 "WebScriptGrammar.y"
{ yyval.stringVal = EMPTYSTRING; ;
    break;}
case 52:
#line 350 "WebScriptGrammar.y"
{ yyval.stringVal = yyvsp[0].stringVal; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/local/lib/bison/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 353 "WebScriptGrammar.y"


extern void ADSetWebScriptFile(FILE *file);
extern int  ADWebScriptLineNumber();

void ADParseWebScriptFile(ADFile *fileContents)
{
	FILE *wosFile;
	int debugLevel = ADIntForDefault(ADDebugLevel);
	
#if YYDEBUG != 0
	yydebug = (debugLevel >= 5);
#endif

	if ([fileContents headerFilename])
	{
		wosFile = fopen([[fileContents headerFilename] cString], "r");
		if (wosFile)
		{
			ADDebugLog(1, @"Parsing %@...", [fileContents headerFilename]);
			ADSetWebScriptFile(wosFile);
			globalFileContents = fileContents;
			globalClass = [[ADClass alloc] init];
			yyparse();
			fclose(wosFile);
			wosFile = NULL;

            /*
             * If there were any methods implemented on the assumed class,
             * then it becomes the mainInterface.  Otherwise, if no methods
             * were declared, then we ignore it and let the first
             * @interface section stay as the mainInterface.
             */
			if (![fileContents hasMainInterface] || [[globalClass declarationArray] count] > 0)
			{
				NSString *filename  = [[fileContents headerFilename] lastPathComponent];
				NSString *className = [filename stringByDeletingPathExtension];
	
				[globalClass setClassName:className];
				if ([className isEqual:@"Application"])
					[globalClass setSuperclassName:@"WOApplication"];
				else if ([className isEqual:@"Session"])
					[globalClass setSuperclassName:@"WOSession"];
				else
					[globalClass setSuperclassName:@"WOComponent"];
	
				[fileContents addClass:globalClass];
				[fileContents setMainInterface:globalClass];
			}

			[globalClass release];
			globalClass = nil;
		}
	}
}


int yyerror(char *s)
{
    // We get errors when parsing WOS files using the "modern" syntax, and
    // possibly at other times when there's valid syntax, so we're not
    // logging errors unless debugging is turned on.
	ADDebugLog(1, @"Parse error: %@: %d: %s\n",
		[ADFILE headerFilename], ADWebScriptLineNumber(), s);

	return 1;
}

